//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     LimeGreen
#property indicator_color2     DarkOrange
#property indicator_color3     Gray
#property indicator_width1     2
#property indicator_width2     2
#property indicator_maximum    1
#property indicator_minimum    0

//
//
//
//
//

extern string TimeFrame = "Current time frame";
extern int    Length    = 25;
extern int    MomPeriod =  5;
extern int    Price     = PRICE_TYPICAL;
extern double LevelOb   =  0.8;
extern double LevelOs   = -0.8;
extern bool   ColorOnSlope = false;

//
//
//
//
//

double rsx[];
double rsxUp[];
double rsxDn[];
double rsxNe[];
double slope[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,rsxUp); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,rsxDn); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,rsxNe); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,rsx);
      SetIndexBuffer(4,slope);
      
       //
       //
       //
       //
       //
     
        indicatorFileName = WindowExpertName();
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        timeFrame         = stringToTimeFrame(TimeFrame); 
        
      //
      //
      //
      //
      // 
     
   IndicatorShortName(timeFrameToString(timeFrame)+" Ift Rmi - rsx smoothed ("+Length+","+MomPeriod+")");
return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

double wrkBuffer[][13];

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { rsxUp[0] = limit+1; return(0); }
         
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
     double Kg = (3.0)/(2.0+Length); 
     double Hg = 1.0-Kg;
     if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);
     for(i=limit, r=Bars-i-1; i>=0; i--, r++)
     {
        wrkBuffer[r][12] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
        if (i==(Bars-1)) { for (int c=0; c<12; c++) wrkBuffer[r][c] = 0; continue; }  

        //
        //
        //
        //
        //

        double mom = 0;
        double mop = 0;
        double diff = wrkBuffer[r][12]-wrkBuffer[r-MomPeriod][12];
            if (diff > 0)
                  mop =  diff;
            else  mom = -diff;
        for (int k=0; k<3; k++)
        {
           int kk = k*2;
              wrkBuffer[r][kk+0] = Kg*mom                + Hg*wrkBuffer[r-1][kk+0];
              wrkBuffer[r][kk+1] = Kg*wrkBuffer[r][kk+0] + Hg*wrkBuffer[r-1][kk+1]; mom = 1.5*wrkBuffer[r][kk+0] - 0.5 * wrkBuffer[r][kk+1];
              wrkBuffer[r][kk+6] = Kg*mop                + Hg*wrkBuffer[r-1][kk+6];
              wrkBuffer[r][kk+7] = Kg*wrkBuffer[r][kk+6] + Hg*wrkBuffer[r-1][kk+7]; mop = 1.5*wrkBuffer[r][kk+6] - 0.5 * wrkBuffer[r][kk+7];
        }
        double res = 0;
            if ((mop+mom) != 0) res = 0.1*(MathMin(MathMax(100*mop/(mop+mom),0),100)-50);
        rsx[i] = (MathExp(2*res)-1)/(MathExp(2*res)+1);
      
      
        //
        //
        //
        //
        //
      
       rsxUp[i] = EMPTY_VALUE;
       rsxDn[i] = EMPTY_VALUE;
       rsxNe[i] = EMPTY_VALUE;
       if (ColorOnSlope)
       {
         slope[i] = slope[i+1];
            if (rsx[i]>rsx[i+1])  slope[i] = 1;
            if (rsx[i]<rsx[i+1])  slope[i] =-1;
            if (slope[i]== 1) rsxUp[i] = 1;
            if (slope[i]==-1) rsxDn[i] = 1;
       }            
       else
       {
         slope[i] = 0;
            if (rsx[i]>LevelOb)  slope[i] = 1;
            if (rsx[i]<LevelOs)  slope[i] =-1;
            if (slope[i]== 1)    rsxUp[i] = 1;
            if (slope[i]==-1)    rsxDn[i] = 1;
            if (slope[i]== 0)    rsxNe[i] = 1;
       }
     }      
     return(0);
  }
     
  //
  //
  //
  //
  //
   
     limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
     for (i=limit;i>=0; i--)
     {
        int y = iBarShift(NULL,timeFrame,Time[i]);
           rsxUp[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,MomPeriod,Price,LevelOb,LevelOs,ColorOnSlope,0,y);
           rsxDn[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,MomPeriod,Price,LevelOb,LevelOs,ColorOnSlope,1,y);
           rsxNe[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,MomPeriod,Price,LevelOb,LevelOs,ColorOnSlope,2,y);
     }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}